;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: WirelessUSBLS_1.asm
;;  Version: 1.0, Updated on 2008/6/23 at 12:26:35
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: WirlessUSB LS User Module software implementation file
;;               for CY8C26xxx and related devices.
;;
;;  NOTE: User Module APIs conform to the fastcall16 convention for marshalling
;;        arguments and observe the associated "Registers are volatile" policy.
;;        This means it is the caller's responsibility to preserve any values
;;        in the X and A registers that are still needed after the API functions
;;        returns. For Large Memory Model devices it is also the caller's 
;;        responsibility to perserve any value in the CUR_PP, IDX_PP, MVR_PP and 
;;        MVW_PP registers. Even though some of these registers may not be modified
;;        now, there is no guarantee that will remain the case in future releases.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "psocgpioint.inc"
include "memory.inc"
include "WirelessUSBLS_1.inc"

;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------

export  WirelessUSBLS_1_Start
export _WirelessUSBLS_1_Start

export  WirelessUSBLS_1_SetChannel
export _WirelessUSBLS_1_SetChannel

export  WirelessUSBLS_1_SetPnCode
export _WirelessUSBLS_1_SetPnCode

export  WirelessUSBLS_1_SendData
export _WirelessUSBLS_1_SendData

export  WirelessUSBLS_1_bReadData
export _WirelessUSBLS_1_bReadData

export  WirelessUSBLS_1_Sleep
export _WirelessUSBLS_1_Sleep

export  WirelessUSBLS_1_Wakeup
export _WirelessUSBLS_1_Wakeup

export  WirelessUSBLS_1_GetMid
export _WirelessUSBLS_1_GetMid

export  WirelessUSBLS_1_bGetRssi
export _WirelessUSBLS_1_bGetRssi

export  WirelessUSBLS_1_SetTxPowerLevel
export _WirelessUSBLS_1_SetTxPowerLevel

export  WirelessUSBLS_1_bGetTxPowerLevel
export _WirelessUSBLS_1_bGetTxPowerLevel

IF WirelessUSBLS_1_NON_BLOCKING_CALLS
export  WirelessUSBLS_1_StartNonBlockingRead
export _WirelessUSBLS_1_StartNonBlockingRead

export  WirelessUSBLS_1_bCheckRxInt
export _WirelessUSBLS_1_bCheckRxInt

export  WirelessUSBLS_1_bCheckRxInProgress
export _WirelessUSBLS_1_bCheckRxInProgress

export  WirelessUSBLS_1_StopNonBlockingRead
export _WirelessUSBLS_1_StopNonBlockingRead
ENDIF  ; WirelessUSBLS_1_NON_BLOCKING_CALLS

export  WirelessUSBLS_1_bReadRegister
export _WirelessUSBLS_1_bReadRegister

export  WirelessUSBLS_1_WriteRegister
export _WirelessUSBLS_1_WriteRegister

export WirelessUSBLS_1_ReadData         ; only exported for ISR. This is NOT a public routine
export WirelessUSBLS_1_WriteAddress     ; only exported for ISR. This is NOT a public routine

AREA  InterruptRAM(RAM, REL, CON)        

export bRadioTemp           ; only exported for ISR. This is NOT a public variable

bRadioTemp:                 
    blk 1
bRadioTemp2:                 
    blk 1

                           
area UserModules (ROM, REL)

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_Start
;
;  DESCRIPTION:
;   Initializes and configures the radio by resetting the radio, delaying 
;   CrystalStartupTime(msec) to stabilize the crystal, initializing the SPI, 
;   and loading the radio configuration data.
;   
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  none
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;

 WirelessUSBLS_1_Start:
_WirelessUSBLS_1_Start:
    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_SETPAGE_CUR >bRadioTemp

    M8C_SetBank1
    or    REG[PRT0DM0], B8h
    and   REG[PRT0DM0], BDh
    or    REG[PRT0DM1], 42h
    and   REG[PRT0DM1], 47h
    and   REG[PRT0IC0], 05h
    or    REG[PRT0IC1], 40h
    and   REG[PRT0IC1], 45h

    or    REG[PRT1DM0], 08h
    and   REG[PRT1DM1], F7h
    and   REG[PRT1IC0], F7h
    and   REG[PRT1IC1], F7h

    M8C_SetBank0
    and   REG[PRT0DM2], 05h
    and   REG[PRT0GS],  05h

    and   REG[PRT1DM2], F7h
    and   REG[PRT1GS],  F7h

    and   REG[PRT0IE], ~IRQ_PIN
    and   REG[PRT1DR], ~NPD_PIN
    and   REG[PRT0DR], ~NRESET_PIN
    or    REG[PRT1DR], NPD_PIN
    or    REG[PRT0DR], NSS_PIN

    mov   a, WirelessUSBLS_1_CRYSTAL_STARTUP_TIME
    asl   a    
    call  WirelessUSBLS_1_TimerDelayMsec
    or    REG[PRT0DR], NRESET_PIN
    
    mov   [bRadioTemp], (EndRadioStartTable - RadioStartTable)

.RadioStartLoop:
    dec   [bRadioTemp]
    mov   a, [bRadioTemp]    
    index RadioStartTable
    mov   x, a
    dec   [bRadioTemp]
    mov   a, [bRadioTemp]
    index RadioStartTable
    call  WirelessUSBLS_1_WriteRegister
    cmp   [bRadioTemp], 0
    jnz   .RadioStartLoop 

IF (WirelessUSBLS_1_NON_BLOCKING_CALLS)
    RAM_SETPAGE_CUR >fRxDone
    mov   [fRxDone], 0
ENDIF ; WirelessUSBLS_1_NON_BLOCKING_CALLS

;    call  RadioDumpRegisters

    RAM_EPILOGUE RAM_USE_CLASS_4 
    ret
.ENDSECTION


;.SECTION
;RadioDumpRegisters:
;    RAM_PROLOGUE RAM_USE_CLASS_4
;    RAM_SETPAGE_CUR >bRadioTemp
;    mov   [bRadioTemp], 3Fh
;.dumploop:
;    mov   a, [bRadioTemp]
;    call  WirelessUSBLS_1_bReadRegister
;    dec   [bRadioTemp]
;    jnz   .dumploop
;
;    RAM_EPILOGUE RAM_USE_CLASS_4 
;    ret
;.ENDSECTION



.SECTION    

;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_SetMode
;
;  DESCRIPTION: Sets the radio to either receive mode, transmit mode, or idle
;                  mode.  
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: Mode - TX, RX, or idle 
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
;          
 WirelessUSBLS_1_SetMode:
_WirelessUSBLS_1_SetMode:
   RAM_PROLOGUE RAM_USE_CLASS_4

    push  X
    and   REG[PRT0IE], ~IRQ_MASK        ; disable RX interrupt
    cmp   A, RADIO_MODE_RX
    jz    .SetModeRx
    cmp   A, RADIO_MODE_TX
    jz    .SetModeTx
    cmp   A, RADIO_MODE_IDLE
    jz    .SetModeIdle

.SetModeDone:
    pop   X
    RAM_EPILOGUE RAM_USE_CLASS_4
    ret


.SetModeRx:
    mov   a, REG_CONTROL
    mov   x, 0
    call  WirelessUSBLS_1_WriteRegister

    mov   a, REG_RX_INT_STAT
    call  WirelessUSBLS_1_bReadRegister
       
    mov   a, REG_CONTROL
    mov   x, RX_ENABLE | AUTO_SYNTH_COUNT
    call  WirelessUSBLS_1_WriteRegister

    jmp   .SetModeDone

.SetModeTx:
    mov   a, REG_CONTROL
    mov   x, 0
    call  WirelessUSBLS_1_WriteRegister

    mov   a, REG_CONTROL
    mov   x, TX_ENABLE | AUTO_SYNTH_COUNT
    call  WirelessUSBLS_1_WriteRegister
    
    jmp   .SetModeDone

.SetModeIdle:
IF WirelessUSBLS_1_NON_BLOCKING_CALLS
    RAM_SETPAGE_CUR >fRxDone
    mov   [fRxDone], RX_NO_BLOCK
ENDIF

    mov   a, REG_CONTROL
    mov   x, 0
    call  WirelessUSBLS_1_WriteRegister
    
    jmp   .SetModeDone
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_SetChannel
;
;  DESCRIPTION:
;   Sets the frequency of the radio. Channels are spaced at 1 MHz intervals 
;   with channel 0 centered at 2.402 GHz and channel 78 centered at 2.480 GHz.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  bChannel - An 8 bit value used to define the channel of the
;   radio.  Channels that are used are the valid channels in the 2.4GHz 
;   frequency band. Valid channels include channels 0 through 77 (2.402 - 
;   2.479).  (See WirelessUSB LS Theory of Operation)
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
; 
 WirelessUSBLS_1_SetChannel:
_WirelessUSBLS_1_SetChannel:

    RAM_PROLOGUE RAM_USE_CLASS_1
    push  x
    add   a, WirelessUSBLS_1_CHANNEL_OFFSET  ; adding channel offset
    and   a, 7Fh                              ; channel mask
    mov   x, a
    mov   a, REG_CHANNEL
    call  WirelessUSBLS_1_WriteRegister
    pop   x
    RAM_EPILOGUE RAM_USE_CLASS_1
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_SetPnCode
;
;  DESCRIPTION:
;   Loads the 8-byte PN code pointed to by pbPnCode into the correlator.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  pbPnCode - A pointer to an array of 8 bytes used to define the 
;   PN code of the radio. (See WirelessUSB LS Theory of Operation)
;
;   pn code MSB is in A
;   pn code LSB is in X
;
;  RETURNS: none
;
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_SetPnCode:
_WirelessUSBLS_1_SetPnCode:

    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_SETPAGE_CUR >bRadioTemp
    mov   [bRadioTemp], 0

.RadioSetPnCodeLoop:
    push  a
    push  x
    romx  
    mov   x, a
    mov   a, REG_PN_CODE
    add   a, [bRadioTemp]
    call  WirelessUSBLS_1_WriteRegister
    pop   x
    pop   a
    inc   x
    inc   [bRadioTemp]
    cmp   [bRadioTemp], 8
    jnz   .RadioSetPnCodeLoop
    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_SendData
;
;  DESCRIPTION:
;   Transmits data from the radio.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: bLength - An 8 bit value used to define the length of the data being transmitted.
;             pbData - A pointer to an array of bytes to be transmitted.
;
;   [SP-5] => MSB of data pointer
;   [SP-4] => LSB of data pointer
;   [SP-3] => length of data
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
RADIO_POINTER_MSB:     equ -5
RADIO_POINTER_LSB:     equ -4
RADIO_DATA_LEN:        equ -3

TEMP1:                 equ 0
TEMP2:                 equ 1


 WirelessUSBLS_1_SendData:
_WirelessUSBLS_1_SendData:

    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_PROLOGUE RAM_USE_CLASS_2
    RAM_SETPAGE_CUR >bRadioTemp
    mov   X, SP
    add   SP, 2

    push  X                        ; push stack pointer

    mov   X, TX_EMPTY
    mov   A, REG_TX_INT_EN
    call  WirelessUSBLS_1_WriteRegister

    mov   A, RADIO_MODE_TX
    call  WirelessUSBLS_1_SetMode

    pop   X                        ; pop stack pointer

    mov   [X+TEMP1],0
    jmp   .RadioSendDataLoopCheck

.RadioSendDataWaitEmpty:
    mov    A, REG[PRT0DR]
    and    A, IRQ_PIN
    jz    .RadioSendDataWaitEmpty

    mov   A, [X+RADIO_POINTER_MSB]
    RAM_SETPAGE_MVR A
    mov   A, [X+RADIO_POINTER_LSB]
    mov   [bRadioTemp], A
    mvi   A, [bRadioTemp]
    push  X                        ; push stack pointer
    push  A                        ; push SendData data byte
    mov   A, REG_DATA_TX
    pop   X                        ; pop SendData data byte
    call  WirelessUSBLS_1_WriteRegister
    pop   X                        ; pop stack pointer
    inc   [X+TEMP1]
    inc   [X+RADIO_POINTER_LSB]
    adc   [X+RADIO_POINTER_MSB], 0
    
.RadioSendDataLoopCheck:    
    mov   A, [X+TEMP1]
    cmp   A, [X+RADIO_DATA_LEN]                    ; compare counter to buffer_length
    jc    .RadioSendDataWaitEmpty

    push  X                          ; push stack pointer
    mov   X, TX_EOF
    mov   A, REG_TX_INT_EN
    call  WirelessUSBLS_1_WriteRegister
    pop   X                          ; pop stack pointer

.RadioSendDataWaitEof:
    mov    A, REG[PRT0DR]
    and    A, IRQ_PIN
    jz    .RadioSendDataWaitEof

    mov   A, RADIO_MODE_IDLE
    call  WirelessUSBLS_1_SetMode

    add   SP, -2
    ret   
.ENDSECTION


IF WirelessUSBLS_1_NON_BLOCKING_CALLS

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_StartNonBlockingRead
;
;  DESCRIPTION:
;   Initializes receive mode and enables the interrupt service routine. The 
;   ISR will be called each time a byte is received.  In order for non-
;   blocking receive mode to function properly psocgpioint.asm must call the 
;   receive ISR routine.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  bLength - An 8 bit value used to define the length of the 
;                 receive buffer.
;              pbData - A pointer to a buffer that stores the received data.
;              pbValid - A pointer to a buffer that checks the validity of the 
;                 received packet.
;
;  valid_buffer         --> X-8
;  rx_buffer            --> X-6
;  buffer_length        --> X-4
;
;
;  RETURNS: bRxDataLength - An 8 bit value of the length of the data (in 
;              bytes) that was received.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;

bValidBufferMsb:       equ -7
bValidBufferLsb:       equ -6
bRxBufferMsb:          equ -5
bRxBufferLsb:          equ -4
bBufferLength:         equ -3

 WirelessUSBLS_1_StartNonBlockingRead:
_WirelessUSBLS_1_StartNonBlockingRead:
    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_PROLOGUE RAM_USE_CLASS_2
    RAM_SETPAGE_CUR >fRxDone
    mov   X, SP

    mov   A, [X+bValidBufferMsb]
    mov   [bIntRxValidBuffer], A
    mov   A, [X+bValidBufferLsb]
    mov   [bIntRxValidBuffer+1], A
    mov   A, [X+bRxBufferMsb]
    mov   [bIntRxDataBuffer], A
    mov   A, [X+bRxBufferLsb]
    mov   [bIntRxDataBuffer+1], A
    mov   A, [X+bBufferLength]
    mov   [bIntRxBufferLength], A
    mov   [bIntRxDataLength], 0
    mov   [fRxDone], RX_NO_BLOCK

    mov   A, RADIO_MODE_RX
    call  WirelessUSBLS_1_SetMode
    or    REG[PRT0IE], IRQ_PIN

.RadioModeRxDone:
    RAM_EPILOGUE RAM_USE_CLASS_2
    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_bCheckRxInt
;
;  DESCRIPTION:
;   Checks for an EOF to be reached during non-blocking receive mode.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  none
;
;  RETURNS: bIntRxDataLength - An 8 bit value of the length of the data (in 
;              bytes) that was received.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_bCheckRxInt:
_WirelessUSBLS_1_bCheckRxInt:
    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_SETPAGE_CUR >fRxDone
    mov   A, [fRxDone]
    and   A, RX_DONE
    jnz   .ReturnLength
    mov   A, 0
    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.ReturnLength:
    mov   [fRxDone], 0
    mov   A, [bIntRxDataLength]

    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_bCheckRxInProgress
;
;  DESCRIPTION:
;   Checks to see if a non-blocking receive is in progress
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  none
;
;  RETURNS:  bStatus - 1 if in progress, else 0
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_bCheckRxInProgress:
_WirelessUSBLS_1_bCheckRxInProgress:
    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_SETPAGE_CUR >fRxDone
    mov   A, [bIntRxDataLength]
    jnz   .InProgress
    mov   A, 0
    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.InProgress:
    mov   A, RX_DONE

    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_StopNonBlockingRead
;
;  DESCRIPTION: Stops the NonBlocking read by taking the radio out of receive
;                  mode and disabling the ISR
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: none 
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_StopNonBlockingRead:
_WirelessUSBLS_1_StopNonBlockingRead:
    RAM_PROLOGUE RAM_USE_CLASS_4

    and   REG[PRT0IE], ~IRQ_MASK
    mov   A, RADIO_MODE_IDLE
    call  WirelessUSBLS_1_SetMode

    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.ENDSECTION

ENDIF  ; WirelessUSBLS_1_NON_BLOCKING_CALLS

                                            
.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_bReadData
;
;  DESCRIPTION:
;   Receives bytes of data from the radio until an EOF has been received or 
;   the timeout is reached. The Timeout is specified in 15usec units.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  bLength - An 8 bit value used to define the length of the 
;                 receive buffer.
;              pbData - A pointer to a buffer to store the received data.
;              pbValid - A pointer to a buffer to store the valid mask of the 
;                 received data. This buffer is useful for error detection and 
;                 correction.
;              wTimeout - A 16 bit timeout counter used in case an acknowledge 
;                 is never received. (10 usec units)
;
;  loop_counter         --> X+1
;  irq_source           --> X+0
;  timeout              --> X-10
;  valid_buffer         --> X-8
;  rx_buffer            --> X-6
;  buffer_length        --> X-4
;
;
;  RETURNS: bRxDataLength:  An 8 bit value of the length of the data (in 
;              bytes) that was received.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;

bRxDataLength:         equ 3
bLoopCounterLsb:       equ 2
bLoopCounterMsb:       equ 1
bIrqSource:            equ 0
bTimeoutMsb:           equ -9
bTimeoutLsb:           equ -8
bValidBufferMsb:       equ -7
bValidBufferLsb:       equ -6
bRxBufferMsb:          equ -5
bRxBufferLsb:          equ -4
bBufferLength:         equ -3


 WirelessUSBLS_1_bReadData:
_WirelessUSBLS_1_bReadData:
    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_PROLOGUE RAM_USE_CLASS_2
    RAM_SETPAGE_CUR >bRadioTemp
    mov   X, SP
    add   SP, 4
    mov   [X+bLoopCounterLsb], 0
    mov   [X+bLoopCounterMsb], 0
    mov   A, RADIO_MODE_RX
    call  WirelessUSBLS_1_SetMode

    mov   [X+bRxDataLength], 0
    jmp   .WhileLoopCheck

.BeginWhileLoop:
    tst   REG[PRT0DR], IRQ_PIN
    jz    .IrqNotAsserted

    and   REG[PRT0DR], ~NSS_PIN
    and   REG[PRT0DR], ~MOSI_PIN
    or    REG[PRT0DR], SCLK_PIN
    and   REG[PRT0DR], ~SCLK_PIN
    or    REG[PRT0DR], MOSI_PIN
    or    REG[PRT0DR], SCLK_PIN
    and   REG[PRT0DR], ~SCLK_PIN

    mov   A,REG_RX_INT_STAT
    call  WirelessUSBLS_1_WriteAddress  ; writes the 6-bit register address
    call  WirelessUSBLS_1_ReadData      ; read REG_RX_INT_STAT

    mov   [X+bIrqSource], A
    tst   [X+bIrqSource], RX_FULL_A
    jz    .CheckEofInt

    ; if (bRxDataLength < bBufferLength)
.CheckForBufferOverflow:
    mov   A, [X+bRxDataLength]
    cmp   A, [X+bBufferLength]
    jc    .ReadData

.BufferOverflow:
    mov   [X+bRxDataLength], 0          ; reset buffer length so that we don't get a buffer overflow
    jmp   .WhileLoopDone

.ReadData:
    call  WirelessUSBLS_1_ReadData      ; read REG_RX_DATA_A
    push  A
IF SYSTEM_LARGE_MEMORY_MODEL 
    mov   A, [X+bRxBufferMsb]
    RAM_SETPAGE_MVW A
ENDIF
    mov   A, [X+bRxBufferLsb]
    add   A, [X+bRxDataLength]
    mov   [bRadioTemp], A
    pop   A
    mvi   [bRadioTemp], A

    tst   [X+bIrqSource], RX_VALID_A
    jz    .ReadValidRegister

    or    REG[PRT0DR], NSS_PIN
IF SYSTEM_LARGE_MEMORY_MODEL
    mov   A, [X+bValidBufferMsb]
    RAM_SETPAGE_MVW A    
ENDIF
    mov   A, [X+bValidBufferLsb]
    add   A, [X+bRxDataLength]
    mov   [bRadioTemp], A
    mov   A, FFh
    mvi   [bRadioTemp], A
    jmp   .IncrementLength

.ReadValidRegister:
    call  WirelessUSBLS_1_ReadData      ; read REG_RX_VALID_A
    or    REG[PRT0DR], NSS_PIN
    push  A  
IF SYSTEM_LARGE_MEMORY_MODEL
    mov   A, [X+bValidBufferMsb]
    RAM_SETPAGE_MVW A    
ENDIF
    mov   A, [X+bValidBufferLsb]
    add   A, [X+bRxDataLength]
    mov   [bRadioTemp], A
    pop   A
    mvi   [bRadioTemp], A
    cmp   a, 0Fh
    jnc   .IncrementLength
    mov   A, 0
    cmp   A, [X+bRxDataLength]
    jnc   .CheckEofInt

.IncrementLength:
    inc   [X+bRxDataLength]
    mov   [X+bLoopCounterLsb], 0
    mov   [X+bLoopCounterMsb], 0

.CheckEofInt:
    ; if(bIrqSource & RX_EOF_A)
    or    REG[PRT0DR], NSS_PIN
    tst   [X+bIrqSource], RX_EOF_A
    jz    .WhileLoopCheck

    cmp   [X+bRxDataLength],0
    jz    .WhileLoopCheck

    jmp   .WhileLoopDone

.IrqNotAsserted:
    inc   [X+bLoopCounterLsb]
    adc   [X+bLoopCounterMsb], 0
    call  WirelessUSBLS_1_TimerDelay10Usec

.WhileLoopCheck:
    mov   A, [X+bLoopCounterLsb]
    sub   A, [X+bTimeoutLsb]
    mov   A, [X+bLoopCounterMsb]
    sbb   A, [X+bTimeoutMsb]
    jc    .BeginWhileLoop
    cmp   [X+bRxDataLength],0
    jnz   .BeginWhileLoop

.WhileLoopDone:
    mov   A, RADIO_MODE_IDLE
    call  WirelessUSBLS_1_SetMode

    mov   A, [X+bRxDataLength]
    add   SP, -4
    RAM_EPILOGUE RAM_USE_CLASS_2
    RAM_EPILOGUE RAM_USE_CLASS_4
    ret   
.ENDSECTION

;ENDIF  ; WirelessUSBLS_1_NON_BLOCKING_CALLS


.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_Sleep
;
;  DESCRIPTION:
;   Puts the radio into sleep mode, which reduces the current to conserve power.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  none
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_Sleep:
_WirelessUSBLS_1_Sleep:
    RAM_PROLOGUE RAM_USE_CLASS_1
IF WirelessUSBLS_1_CRYSTAL_ADJUST
    mov   x, CLOCK_DISABLE
    mov   a, REG_XTAL_ADJ
    call  WirelessUSBLS_1_WriteRegister
ENDIF   ; WirelessUSBLS_1_CRYSTAL_ADJUST

    M8C_SetBank1
    and   REG[PRT0DM1], ~MISO_PIN                    ; PORT 0 Drive Mode 1
    M8C_SetBank0
    and   REG[PRT1DR], ~NPD_PIN

    RAM_EPILOGUE RAM_USE_CLASS_1
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_Wakeup
;
;  DESCRIPTION:
;   Brings the radio out of sleep mode; this function has a delay of 
;   CrystalStartUpTime msec. If CrystalAdjust is non-zero there is an 
;   additional delay of 2 msec
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  none
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_Wakeup:
_WirelessUSBLS_1_Wakeup:
    RAM_PROLOGUE RAM_USE_CLASS_1

    M8C_SetBank1
    or    REG[PRT0DM1], MISO_PIN           ; PORT 0 Drive Mode 1
    M8C_SetBank0
    or    REG[PRT1DR], NPD_PIN

    mov   a, WirelessUSBLS_1_CRYSTAL_STARTUP_TIME
    call  WirelessUSBLS_1_TimerDelayMsec
    
    
IF WirelessUSBLS_1_CRYSTAL_ADJUST
    mov   x, WirelessUSBLS_1_CRYSTAL_ADJUST
    and   x, XTAL_ADJ_MASK
    or    x, CLOCK_DISABLE
    mov   a, REG_XTAL_ADJ
    call  WirelessUSBLS_1_WriteRegister

    ; crystal requires 2ms to settle again after adjusting the crystal
    mov   a, 2
    call  WirelessUSBLS_1_TimerDelayMsec
ENDIF   ; WirelessUSBLS_1_CRYSTAL_ADJUST
    RAM_EPILOGUE RAM_USE_CLASS_1
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_GetMid
;
;  DESCRIPTION:
;   Gets the Manufacturing ID (MID) that is stored in the radio
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  pbMid:  A pointer to a four byte buffer to store the MID of the 
;                 radio.
;
;             bMidLsb:       equ -2
;             bMidMsb:       equ -1
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
bMidLsb:       equ -2
bMidMsb:       equ -1


 WirelessUSBLS_1_GetMid:
_WirelessUSBLS_1_GetMid:
    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_PROLOGUE RAM_USE_CLASS_2
;    RAM_SETPAGE_IDX A
    RAM_SETPAGE_CUR >bRadioTemp

    push  x
    push  a
        
    mov   X, SP
    
    ; turn on MID registers
    push  x
    mov   x, AGC_RSSI_CTL | PACTL_EN | MID_READ_EN
    mov   a, REG_ANALOG_CTL
    call  WirelessUSBLS_1_WriteRegister
    mov   a, 0          ; store counter on stack
    pop   x

.RadioGetMidLoop:
    push  a
    add   a, REG_MFG_ID_1
    call  WirelessUSBLS_1_bReadRegister          ; A now contains the ID register contents
    push  a

    ; now I need to move A to the specified RAM location....
    mov   A, [X+bMidMsb]
    RAM_SETPAGE_MVW A
    mov   A, [X+bMidLsb]
    mov   [bRadioTemp], A
    pop   A
    mvi   [bRadioTemp], A

    inc   [X+bMidLsb]
    adc   [X+bMidMsb], 0

    pop   a
    inc   a
    cmp   a, 4
    jnz   .RadioGetMidLoop

    
    ; turn off MID registers
    mov   x, AGC_RSSI_CTL | PACTL_EN
    mov   a, REG_ANALOG_CTL
    call  WirelessUSBLS_1_WriteRegister
    
    add   SP, -2            ; reset the stack pointer to the original value

    RAM_EPILOGUE RAM_USE_CLASS_2
    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_bGetRssi
;
;  DESCRIPTION:
;   Returns the signal strength of the channel noise floor.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  none
;
;  RETURNS: An 8 bit value of the current valid RSSI reading. (Range: 0x00 - 
;             0x1F)
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_bGetRssi:
_WirelessUSBLS_1_bGetRssi:
    RAM_PROLOGUE RAM_USE_CLASS_1
    mov   a, REG_RSSI
    call  WirelessUSBLS_1_bReadRegister            ; first call to WirelessUSBLS_1_ReadRegister flushes the RSSI register
    mov   a, REG_RSSI
    call  WirelessUSBLS_1_bReadRegister            ; second call gets current RSSI value
    
    cmp   a, RSSI_VALID
    jnc   .ValidRssi
    mov   a, 0                      ; invalid RSSI, return 0
    RAM_EPILOGUE RAM_USE_CLASS_1
    ret

.ValidRssi:
    and   a, RSSI_MASK
    RAM_EPILOGUE RAM_USE_CLASS_1
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_bGetTxPowerLevel
;
;  DESCRIPTION:
;   Retrieves the current power amplitude level used for transmitting data.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  none
;
;  RETURNS: An 8 bit value of the current power amplitude level. (Range: 0-7)
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_bGetTxPowerLevel:
_WirelessUSBLS_1_bGetTxPowerLevel:
    RAM_PROLOGUE RAM_USE_CLASS_1
    mov   a, REG_PA
    call  WirelessUSBLS_1_bReadRegister
    RAM_EPILOGUE RAM_USE_CLASS_1
    ret
.ENDSECTION

.SECTION    
;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_SetTxPowerLevel
;
;  DESCRIPTION:
;   Sets the power amplitude level for transmitting data.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:  bPowerLevel - An a bit value used to define the power amplitude 
;                level when transmitting data. (Range: 0-7)
;
;  RETURNS: none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_SetTxPowerLevel:
_WirelessUSBLS_1_SetTxPowerLevel:
    RAM_PROLOGUE RAM_USE_CLASS_1
    mov   x, a
    mov   a, REG_PA
    call  WirelessUSBLS_1_WriteRegister
    RAM_EPILOGUE RAM_USE_CLASS_1
    ret
.ENDSECTION


.LITERAL
RadioStartTable:
    db REG_CARRIER_DETECT, CDET        ; MUST be written after REG_ANALOG_CTL.
    db REG_CLOCK_ENABLE, 41h
    db REG_CLOCK_MANUAL, 41h        ; Manually override RSSI clock and RC clock
    db REG_SYN_LOCK_CNT, RADIO_SYNTH_LOCK_COUNT
    db REG_AGC_CTL, AGC_OFF
    db REG_ANALOG_CTL, (AGC_RSSI_CTL | PACTL_EN)
    db REG_VALID_TX, FFh                           ; ALL valid bits (we are transmitting full bytes)
    db REG_SERDES_CTL, (SERDES_ENABLE | (EOF_LEN_MASK & WirelessUSBLS_1_EOF_BITS))              
    db REG_TX_INT_EN, (TX_EMPTY | TX_EOF)    ; empty A, EOF 
    db REG_RX_INT_EN, (RX_EOF_A | RX_FULL_A)   ; only Full AND  EOF on channel A
    db REG_PA, (WirelessUSBLS_1_TX_POWER_LEVEL & PA_BIAS_MASK)
    db REG_VCO_CAL, MINUS_5_PLUS_5
    db REG_XTAL_ADJ, (CLOCK_DISABLE | (WirelessUSBLS_1_CRYSTAL_ADJUST & XTAL_ADJ_MASK))
    db REG_THRESHOLD_HI, (NUM_CHIPS - WirelessUSBLS_1_CHIP_ERROR_THRESHOLD)     ; correlation threshold
    db REG_THRESHOLD_LO, WirelessUSBLS_1_CHIP_ERROR_THRESHOLD     ; correlation threshold
    db REG_DATA_RATE, RADIO_MODE    ; 32/64 chip PN_CODE, DDR select, etc. (see config.inc)
EndRadioStartTable:
.ENDLITERAL    


;-------------------------------------------------------------------
;  Declare the functions global for both assembler and C compiler.
;
;  Note that there are two names for each API. First name is 
;  assembler reference. Name with underscore is name refence for
;  C compiler.  Calling function in C source code does not require 
;  the underscore.
;-------------------------------------------------------------------
WirelessUSBLS_1_TimerDelay10Usec:
    mov   A, 4                // [4] cycles
    jmp   delay_usec_loop;    // [5] cycles

WirelessUSBLS_1_TimerDelay100Usec:
    mov   A, 58               // [4] cycles
    jmp   delay_usec_loop;    // [5] cycles


; num_msec is in A
WirelessUSBLS_1_TimerDelayMsec:
    mov   X, A

.msec_loop:
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    call  WirelessUSBLS_1_TimerDelay100Usec
    dec   x
    jnz   .msec_loop
          
    ret   


delay_usec_loop:
    and   A, FFh              // [4] cycles
    ljmp  .fwd                // [7] cycles
    .fwd:                     // [0] cycles
    dec   A                   // [4] cycles
    jnz   delay_usec_loop     // [5] cycles
    cmp   A, 0                // [5] cycles
    cmp   A, 0                // [5] cycles
    ret                       // [8] cycles


;-----------
;  MACROS
;-----------
macro CLOCK_HI
    or              REG[PRT0DR], SCLK_PIN
endm    

macro CLOCK_LO
    and             REG[PRT0DR], ~SCLK_PIN
endm

macro CLOCK_DATA_LO
    and             REG[PRT0DR], ~(SCLK_PIN | MOSI_PIN)
endm

macro CLOCK
    or              REG[PRT0DR], SCLK_PIN
    and             REG[PRT0DR], ~(SCLK_PIN | MOSI_PIN)
endm

macro DATA1
    or              REG[PRT0DR], MOSI_PIN
endm

macro DATA0
    and             REG[PRT0DR], ~MOSI_PIN
endm    


;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_bReadRegister
;
;  DESCRIPTION:
;   Gets the data stored in the radio register that is passed in through A
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: Address: Address of the register that contains the requested
;               data
;
;  RETURNS: Data: Data that was stored in the register
;
;
;       Address is in A
;
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_bReadRegister:
_WirelessUSBLS_1_bReadRegister:

    push  A
    mov   A, reg[CPU_F]
    and   A, FLAG_GLOBAL_IE
    mov   [bRadioTemp2], A
    pop   A

    M8C_DisableGInt
    and   REG[PRT0DR], ~NSS_PIN
    and   REG[PRT0DR], ~MOSI_PIN
    CLOCK
    CLOCK
        
    call  WirelessUSBLS_1_WriteAddress
    call  WirelessUSBLS_1_ReadData

    or    REG[PRT0DR], NSS_PIN

    push  A
    mov   A, [bRadioTemp2]
    cmp   A, 0
    jz    .exit	

    M8C_EnableGInt

.exit:    

    pop   A

    ret

;-----------------------------------------------------------------------------
;  FUNCTION NAME: WirelessUSBLS_1_WriteRegister
;
;  DESCRIPTION:
;   Writes data to a radio register
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: Address: Address of the register that is to be written
;
;             Data: Data that is written to the register
;
;  RETURNS: none
;
;
;       Address is in A
;       Data is in X
;
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 WirelessUSBLS_1_WriteRegister:
_WirelessUSBLS_1_WriteRegister:

    push  A
    mov   A, reg[CPU_F]
    and   A, FLAG_GLOBAL_IE
    mov   [bRadioTemp2], A
    pop   A

    M8C_DisableGInt
    and   REG[PRT0DR], ~NSS_PIN

;ADDRESS

    ; Set direction bit for write
    or    REG[PRT0DR], MOSI_PIN
    CLOCK
    ; Clear burst read bit
    and   REG[PRT0DR], ~MOSI_PIN
    CLOCK

    call  WirelessUSBLS_1_WriteAddress

    mov   A, X
    call  WirelessUSBLS_1_WriteData

    or    REG[PRT0DR], NSS_PIN
    
    push  A
    mov   A, [bRadioTemp2]
    cmp   A, 0
    jz    .exit	

    M8C_EnableGInt

.exit:   
 
    pop   A

    ret


;---------------------------------------------
;       WirelessUSBLS_1_WriteAddress
;---------------------------------------------
WirelessUSBLS_1_WriteAddress:
    and   REG[PRT0DR], ~MOSI_PIN    ; clear MOSI bit
    ; move address (A) b5 into C
    asl   A
    asl   A
    asl   A
    jnc   .address5
    DATA1
.address5:
CLOCK_HI
CLOCK_DATA_LO
    ; Do bit 4
    asl   A
    jnc   .address4
    DATA1
.address4:
CLOCK_HI
CLOCK_DATA_LO
    ; Do bit 3
    asl   A
    jnc   .address3
    DATA1
.address3:
CLOCK_HI
CLOCK_DATA_LO
    ; Do bit 2
    asl    A
    jnc    .address2
    DATA1
.address2:
CLOCK_HI
CLOCK_DATA_LO
    ; Do bit 1
    asl    A
    jnc    .address1
    DATA1
.address1:
CLOCK_HI
CLOCK_DATA_LO
    ; Do bit 0
    asl    A
    jnc    .address0
    DATA1
.address0:
    CLOCK                                   

    ret

;---------------------------------------------
;       WirelessUSBLS_1_ReadData
;---------------------------------------------
WirelessUSBLS_1_ReadData:    
    mov    A, 0

    ; Now read data
    ; set MOSI high for all bits
    DATA1
    ; Note that A is cleared from previous ASL instructions
    CLOCK_HI
    tst    REG[PRT0DR], MISO_PIN
    jz     rdb7
    inc    A
rdb7:
    CLOCK_LO
    asl    A
    ; Now get b6
    CLOCK_HI
    tst    REG[PRT0DR], MISO_PIN
    jz     rdb6
    inc    A
rdb6:
    CLOCK_LO
    asl    A
    ; Now get b5
    CLOCK_HI
    tst    REG[PRT0DR], MISO_PIN
    jz     rdb5
    inc    A
rdb5:
    CLOCK_LO
    asl    A
    ; Now get b4
    CLOCK_HI
    tst    REG[PRT0DR], MISO_PIN
    jz     rdb4
    inc    A
rdb4:
    CLOCK_LO
    asl    A
    ; Now get b3
    CLOCK_HI
    tst    REG[PRT0DR], MISO_PIN
    jz     rdb3
    inc    A
rdb3:
    CLOCK_LO
    asl    A
    ; Now get b2
    CLOCK_HI
    tst    REG[PRT0DR], MISO_PIN
    jz     rdb2
    inc    A
rdb2:
    CLOCK_LO
    asl    A
    ; Now get b1
    CLOCK_HI
    tst    REG[PRT0DR], MISO_PIN
    jz     rdb1
    inc    A
rdb1:
    CLOCK_LO
    asl    A
    ; Now get b0
    CLOCK_HI
    tst    REG[PRT0DR], MISO_PIN
    jz     rdb0
    inc    A
rdb0:
    CLOCK_LO
    
    ret
        

;---------------------------------------------
;       WirelessUSBLS_1_WriteData
;---------------------------------------------
WirelessUSBLS_1_WriteData:
    DATA0  ;Set output to zero as default
    asl    A
    jnc    wdb7
    DATA1
wdb7:
    CLOCK
    ; Now do bit 6
    asl    A
    jnc    wdb6
    DATA1
wdb6:
    CLOCK           
    ; Now do bit 5
    asl    A
    jnc    wdb5
    DATA1
wdb5:
    CLOCK  ; Now do bit 4
    asl    A
    jnc    wdb4
    DATA1
wdb4:
    CLOCK  ; Now do bit 3
    asl    A
    jnc    wdb3
    DATA1
wdb3:
    CLOCK  ; Now do bit 2
    asl    A
    jnc    wdb2
    DATA1
wdb2:
    CLOCK  ; Now do bit 1
    asl    A
    jnc    wdb1
    DATA1
wdb1:
    CLOCK  ; Now do bit 0
    asl    A
    jnc    wdb0
    DATA1
wdb0:
    CLOCK   
    
    ret

; End of File WirelessUSBLS_1.asm
